Index: /branches/2915-AbsoluteSymbol/HeuristicLab.ExtLibs/HeuristicLab.NativeInterpreter/0.1/NativeInterpreter-0.1/lib/vdt/asin.h
===================================================================
--- /branches/2915-AbsoluteSymbol/HeuristicLab.ExtLibs/HeuristicLab.NativeInterpreter/0.1/NativeInterpreter-0.1/lib/vdt/asin.h	(revision 16332)
+++ /branches/2915-AbsoluteSymbol/HeuristicLab.ExtLibs/HeuristicLab.NativeInterpreter/0.1/NativeInterpreter-0.1/lib/vdt/asin.h	(revision 16332)
@@ -0,0 +1,217 @@
+/*
+ * aasin.h
+ * The basic idea is to exploit Pade' polynomials.
+ * A lot of ideas were inspired by the cephes math library (by Stephen L. Moshier
+ * moshier@na-net.ornl.gov) as well as actual code. 
+ * The Cephes library can be found here:  http://www.netlib.org/cephes/
+ * 
+ *  Created on: Jun 23, 2012
+ *      Author: Danilo Piparo, Thomas Hauth, Vincenzo Innocente
+ */
+
+/* 
+ * VDT is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU Lesser Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ * 
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU Lesser Public License for more details.
+ * 
+ * You should have received a copy of the GNU Lesser Public License
+ * along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#ifndef ASIN_H_
+#define ASIN_H_
+
+#include "vdtcore_common.h"
+
+namespace vdt{
+
+namespace details{
+
+const double RX1asin = 2.967721961301243206100E-3;
+const double RX2asin = -5.634242780008963776856E-1;
+const double RX3asin = 6.968710824104713396794E0;
+const double RX4asin = -2.556901049652824852289E1;
+const double RX5asin = 2.853665548261061424989E1;
+
+const double SX1asin = -2.194779531642920639778E1;
+const double SX2asin =  1.470656354026814941758E2;
+const double SX3asin = -3.838770957603691357202E2;
+const double SX4asin = 3.424398657913078477438E2;
+
+const double PX1asin = 4.253011369004428248960E-3;
+const double PX2asin = -6.019598008014123785661E-1;
+const double PX3asin = 5.444622390564711410273E0;
+const double PX4asin = -1.626247967210700244449E1;
+const double PX5asin = 1.956261983317594739197E1;
+const double PX6asin = -8.198089802484824371615E0;
+
+const double QX1asin = -1.474091372988853791896E1;
+const double QX2asin =  7.049610280856842141659E1;
+const double QX3asin = -1.471791292232726029859E2;
+const double QX4asin = 1.395105614657485689735E2;
+const double QX5asin = -4.918853881490881290097E1;
+
+inline double getRX(const double x){
+	double rx = RX1asin;
+	rx*= x;
+	rx+= RX2asin;
+	rx*= x;    
+	rx+= RX3asin;
+	rx*= x;    
+	rx+= RX4asin;
+	rx*= x;    
+	rx+= RX5asin;
+	return rx;
+}
+inline double getSX(const double x){
+	double sx = x;
+	sx+= SX1asin;
+	sx*= x;    
+	sx+= SX2asin;
+	sx*= x;    
+	sx+= SX3asin;
+	sx*= x;    
+	sx+= SX4asin;
+	return sx;
+}
+
+inline double getPX(const double x){
+	double px = PX1asin;
+	px*= x;
+	px+= PX2asin;
+	px*= x;    
+	px+= PX3asin;
+	px*= x;    
+	px+= PX4asin;
+	px*= x;    
+	px+= PX5asin;
+	px*= x;    
+	px+= PX6asin;
+	return px;
+}
+
+inline double getQX(const double x){
+	double qx = x;
+	qx+= QX1asin;
+	qx*= x;    
+	qx+= QX2asin;
+	qx*= x;    
+	qx+= QX3asin;
+	qx*= x;    
+	qx+= QX4asin;
+	qx*= x;    
+	qx+= QX5asin;
+	return qx;
+	}
+}
+
+}
+
+namespace vdt{
+
+// asin double precision --------------------------------------------------------
+/// Double Precision asin
+inline double fast_asin(double x){	
+
+	const uint64_t sign_mask = details::getSignMask(x);
+	x = std::fabs(x);
+	const double a = x;
+	
+	
+	double zz = 1.0 - a;
+	double px = details::getRX(zz);
+	double qx = details::getSX(zz);
+
+	const double p = zz * px/qx;
+
+	zz = std::sqrt(zz+zz);
+	double z = details::PIO4 - zz;
+	zz = zz * p - details::MOREBITS;
+	z -= zz;
+	z += details::PIO4;
+	
+	if( a < 0.625 ){
+		zz = a * a;
+		px = details::getPX(zz);
+		qx = details::getQX(zz);
+		z = zz*px/qx;    
+		z = a * z + a;
+	}
+	
+
+	// Linear approx, not sooo needed but seable. Price is cheap though
+	double res = a < 1e-8? a : z ;
+        // Restore Sign	
+	return details::dpORuint64(res,sign_mask);
+
+}
+
+//------------------------------------------------------------------------------
+/// Single Precision asin
+inline float fast_asinf(float x){      
+
+
+    uint32_t flag=0;
+
+    const uint32_t sign_mask = details::getSignMask(x);
+    const float a = std::fabs(x);
+
+    float z;
+    if( a > 0.5f )
+        {
+        z = 0.5f * (1.0f - a);
+        x = sqrtf( z );
+        flag = 1;
+        }
+    else
+        {
+        x = a;
+        z = x * x;
+        }
+        
+    z = (((( 4.2163199048E-2f * z
+            + 2.4181311049E-2f) * z
+            + 4.5470025998E-2f) * z
+            + 7.4953002686E-2f) * z
+            + 1.6666752422E-1f) * z * x
+            + x;
+
+//     if( flag != 0 )
+//       {
+//       z = z + z;
+//       z = PIO2F - z;
+//       }
+
+    // No branch with the two coefficients
+            
+    float tmp = z + z;
+    tmp = details::PIO2F - tmp;
+
+    // Linear approx, not sooo needed but seable. Price is cheap though
+    float res = a < 1e-4f? a : tmp * flag + (1-flag) * z ;
+    
+    // Restore Sign 
+    return details::spORuint32(res,sign_mask);
+
+}
+
+//------------------------------------------------------------------------------
+// The cos is in this file as well
+
+inline double fast_acos( double x ){return details::PIO2  - fast_asin(x);}
+
+//------------------------------------------------------------------------------
+
+inline float fast_acosf( float x ){return details::PIO2F  - fast_asinf(x);}
+
+//------------------------------------------------------------------------------
+
+} //vdt namespace
+
+#endif /* ASIN_H_ */
Index: /branches/2915-AbsoluteSymbol/HeuristicLab.ExtLibs/HeuristicLab.NativeInterpreter/0.1/NativeInterpreter-0.1/lib/vdt/atan.h
===================================================================
--- /branches/2915-AbsoluteSymbol/HeuristicLab.ExtLibs/HeuristicLab.NativeInterpreter/0.1/NativeInterpreter-0.1/lib/vdt/atan.h	(revision 16332)
+++ /branches/2915-AbsoluteSymbol/HeuristicLab.ExtLibs/HeuristicLab.NativeInterpreter/0.1/NativeInterpreter-0.1/lib/vdt/atan.h	(revision 16332)
@@ -0,0 +1,163 @@
+/*
+ * atan.h
+ * The basic idea is to exploit Pade polynomials.
+ * A lot of ideas were inspired by the cephes math library (by Stephen L. Moshier
+ * moshier@na-net.ornl.gov) as well as actual code. 
+ * The Cephes library can be found here:  http://www.netlib.org/cephes/
+ * 
+ *  Created on: Jun 23, 2012
+ *      Author: Danilo Piparo, Thomas Hauth, Vincenzo Innocente
+ */
+
+/* 
+ * VDT is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU Lesser Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ * 
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU Lesser Public License for more details.
+ * 
+ * You should have received a copy of the GNU Lesser Public License
+ * along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#ifndef ATAN_H_
+#define ATAN_H_
+
+#include "vdtcore_common.h"
+
+namespace vdt{
+
+namespace details{
+const double T3PO8 = 2.41421356237309504880;
+const double MOREBITSO2 = MOREBITS * 0.5;
+
+inline double get_atan_px(const double x2){
+
+	const double PX1atan = -8.750608600031904122785E-1;
+	const double PX2atan = -1.615753718733365076637E1;
+	const double PX3atan = -7.500855792314704667340E1;
+	const double PX4atan = -1.228866684490136173410E2;
+	const double PX5atan = -6.485021904942025371773E1;
+
+	double px = PX1atan;
+	px *= x2;
+	px += PX2atan;
+	px *= x2;
+	px += PX3atan;
+	px *= x2;
+	px += PX4atan;
+	px *= x2;
+	px += PX5atan;
+
+	return px;
+}
+
+
+inline double get_atan_qx(const double x2){
+	const double QX1atan = 2.485846490142306297962E1;
+	const double QX2atan = 1.650270098316988542046E2;
+	const double QX3atan = 4.328810604912902668951E2;
+	const double QX4atan = 4.853903996359136964868E2;
+	const double QX5atan = 1.945506571482613964425E2;
+
+	double qx=x2;
+	qx += QX1atan;
+	qx *=x2;
+	qx += QX2atan;
+	qx *=x2;
+	qx += QX3atan;
+	qx *=x2;
+	qx += QX4atan;
+	qx *=x2;
+	qx += QX5atan;
+
+	return qx;
+}
+
+}
+
+
+
+/// Fast Atan implementation double precision
+inline double fast_atan(double x){
+
+	/* make argument positive and save the sign */
+	const uint64_t sign_mask = details::getSignMask(x);
+	x=std::fabs(x);
+
+	/* range reduction */
+	const double originalx=x;
+
+	double y = details::PIO4;
+	double factor = details::MOREBITSO2;
+	x = (x-1.0) / (x+1.0);
+
+	if( originalx > details::T3PO8 ) {
+		y = details::PIO2;
+		factor = details::MOREBITS;
+		x = -1.0 / originalx ;
+	}
+	if ( originalx <= 0.66 ) {
+		y = 0.;
+		factor = 0.;
+		x = originalx;
+	}
+
+	const double x2 = x * x;
+
+	const double px = details::get_atan_px(x2);
+	const double qx = details::get_atan_qx(x2);
+
+	//double res = y +x * x2 * px / qx + x +factor;
+
+	const double poq=px / qx;
+
+	double res = x * x2 * poq + x;
+	res+=y;
+
+	res+=factor;
+
+	return details::dpORuint64(res,sign_mask);
+}
+
+//------------------------------------------------------------------------------
+/// Fast Atan implementation single precision
+inline float fast_atanf( float xx ) {
+
+	const uint32_t sign_mask = details::getSignMask(xx);
+
+	float x= std::fabs(xx);
+	const float x0=x;
+	float y=0.0f;
+
+	/* range reduction */
+	if( x0 > 0.4142135623730950f ){ // * tan pi/8
+		x = (x0-1.0f)/(x0+1.0f);
+		y = details::PIO4F;
+	}
+	if( x0 > 2.414213562373095f ){  // tan 3pi/8
+		x = -( 1.0f/x0 );
+		y = details::PIO2F;
+	}
+
+
+	const float x2 = x * x;
+	y +=
+			((( 8.05374449538e-2f * x2
+					- 1.38776856032E-1f) * x2
+					+ 1.99777106478E-1f) * x2
+					- 3.33329491539E-1f) * x2 * x
+					+ x;
+
+	return details::spORuint32(y,sign_mask);
+}
+
+//------------------------------------------------------------------------------
+
+}// end of vdt
+
+#endif // end of atan
Index: /branches/2915-AbsoluteSymbol/HeuristicLab.ExtLibs/HeuristicLab.NativeInterpreter/0.1/NativeInterpreter-0.1/lib/vdt/atan2.h
===================================================================
--- /branches/2915-AbsoluteSymbol/HeuristicLab.ExtLibs/HeuristicLab.NativeInterpreter/0.1/NativeInterpreter-0.1/lib/vdt/atan2.h	(revision 16332)
+++ /branches/2915-AbsoluteSymbol/HeuristicLab.ExtLibs/HeuristicLab.NativeInterpreter/0.1/NativeInterpreter-0.1/lib/vdt/atan2.h	(revision 16332)
@@ -0,0 +1,143 @@
+/*
+ * atan2.h
+ * The basic idea is to exploit Pade polynomials.
+ * A lot of ideas were inspired by the cephes math library (by Stephen L. Moshier
+ * moshier@na-net.ornl.gov) as well as actual code.
+ * The Cephes library can be found here:  http://www.netlib.org/cephes/
+ *
+ *  Created on: Sept 20, 2012
+ *      Author: Danilo Piparo, Thomas Hauth, Vincenzo Innocente
+ */
+
+/*
+ * VDT is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU Lesser Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU Lesser Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser Public License
+ * along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#ifndef ATAN2_H_
+#define ATAN2_H_
+
+#include "vdtcore_common.h"
+#include "atan.h"
+
+namespace vdt{
+
+inline double fast_atan2( double y, double x ) {
+    // move in first octant
+    double xx = std::fabs(x);
+    double yy = std::fabs(y);
+    double tmp (0.0);
+    if (yy>xx) {
+        tmp = yy;
+        yy=xx; xx=tmp;
+        tmp=1.;
+    }
+
+    // To avoid the fpe, we protect against /0.
+    const double oneIfXXZero = (xx==0.);
+    double t=yy/(xx+oneIfXXZero);
+    double z=t;
+
+    double s = details::PIO4;
+    double factor = details::MOREBITSO2;
+    t = (t-1.0) / (t+1.0);
+
+    if( z > details::T3PO8 ) {
+        s = details::PIO2;
+        factor = details::MOREBITS;
+        t = -1.0 / z ;
+    }
+    if ( z <= 0.66 ) {
+        s = 0.;
+        factor = 0.;
+        t = z;
+    }
+
+    const double t2 = t * t;
+
+    const double px = details::get_atan_px(t2);
+    const double qx = details::get_atan_qx(t2);
+
+    //double res = y +x * x2 * px / qx + x +factor;
+
+    const double poq=px / qx;
+
+    double ret = t * t2 * poq + t;
+    ret+=s;
+
+    ret+=factor;
+
+    // Here we put the result to 0 if xx was 0, if not nothing happens!
+    ret*= (1.-oneIfXXZero);
+
+    // move back in place
+    if (y==0) ret=0.0;
+    if (tmp!=0) ret = details::PIO2 - ret;
+    if (x<0) ret = details::PI - ret;
+    if (y<0) ret = -ret;
+
+
+    return ret;
+}
+
+inline float fast_atan2f( float y, float x ) {
+
+    // move in first octant
+    float xx = std::fabs(x);
+    float yy = std::fabs(y);
+    float tmp (0.0f);
+    if (yy>xx) {
+        tmp = yy;
+        yy=xx; xx=tmp;
+        tmp =1.f;
+    }
+
+    // To avoid the fpe, we protect against /0.
+    const float oneIfXXZero = (xx==0.f);
+    
+    float t=yy/(xx/*+oneIfXXZero*/);
+    float z=t;
+    if( t > 0.4142135623730950f ) // * tan pi/8
+            z = (t-1.0f)/(t+1.0f);
+
+    //printf("%e %e %e %e\n",yy,xx,t,z);
+    float z2 = z * z;
+    
+    float ret =(((( 8.05374449538e-2f * z2
+                    - 1.38776856032E-1f) * z2
+                    + 1.99777106478E-1f) * z2
+                    - 3.33329491539E-1f) * z2 * z
+                    + z );
+
+    // Here we put the result to 0 if xx was 0, if not nothing happens!
+    ret*= (1.f - oneIfXXZero);
+    
+    // move back in place
+    if (y==0.f) ret=0.f;
+    if( t > 0.4142135623730950f ) ret += details::PIO4F;
+    if (tmp!=0) ret = details::PIO2F - ret;
+    if (x<0.f) ret = details::PIF - ret;
+    if (y<0.f) ret = -ret;
+
+    return ret;
+
+}
+
+
+
+//------------------------------------------------------------------------------
+
+} // end namespace vdt
+
+
+#endif
Index: /branches/2915-AbsoluteSymbol/HeuristicLab.ExtLibs/HeuristicLab.NativeInterpreter/0.1/NativeInterpreter-0.1/lib/vdt/cos.h
===================================================================
--- /branches/2915-AbsoluteSymbol/HeuristicLab.ExtLibs/HeuristicLab.NativeInterpreter/0.1/NativeInterpreter-0.1/lib/vdt/cos.h	(revision 16332)
+++ /branches/2915-AbsoluteSymbol/HeuristicLab.ExtLibs/HeuristicLab.NativeInterpreter/0.1/NativeInterpreter-0.1/lib/vdt/cos.h	(revision 16332)
@@ -0,0 +1,32 @@
+/*
+ * cos.h
+ * The basic idea is to exploit Pade polynomials.
+ * A lot of ideas were inspired by the cephes math library (by Stephen L. Moshier
+ * moshier@na-net.ornl.gov) as well as actual code. 
+ * The Cephes library can be found here:  http://www.netlib.org/cephes/
+ * 
+ *  Created on: Jun 23, 2012
+ *      Author: Danilo Piparo, Thomas Hauth, Vincenzo Innocente
+ */
+
+#ifndef COS_H_
+#define COS_H_
+
+#include "sincos.h"
+
+namespace vdt{
+
+// Cos double precision --------------------------------------------------------
+
+/// Double precision cosine: just call sincos.
+inline double fast_cos(double x){double s,c;fast_sincos(x,s,c);return c;}
+
+//------------------------------------------------------------------------------
+
+inline float fast_cosf(float x){float s,c;fast_sincosf(x,s,c);return c;}
+
+//------------------------------------------------------------------------------
+
+} //vdt namespace
+
+#endif /* COS_H_ */
Index: /branches/2915-AbsoluteSymbol/HeuristicLab.ExtLibs/HeuristicLab.NativeInterpreter/0.1/NativeInterpreter-0.1/lib/vdt/exp.h
===================================================================
--- /branches/2915-AbsoluteSymbol/HeuristicLab.ExtLibs/HeuristicLab.NativeInterpreter/0.1/NativeInterpreter-0.1/lib/vdt/exp.h	(revision 16332)
+++ /branches/2915-AbsoluteSymbol/HeuristicLab.ExtLibs/HeuristicLab.NativeInterpreter/0.1/NativeInterpreter-0.1/lib/vdt/exp.h	(revision 16332)
@@ -0,0 +1,157 @@
+/*
+ * exp.h
+ * The basic idea is to exploit Pade polynomials.
+ * A lot of ideas were inspired by the cephes math library (by Stephen L. Moshier
+ * moshier@na-net.ornl.gov) as well as actual code. 
+ * The Cephes library can be found here:  http://www.netlib.org/cephes/
+ * 
+ *  Created on: Jun 23, 2012
+ *      Author: Danilo Piparo, Thomas Hauth, Vincenzo Innocente
+ */
+
+/* 
+ * VDT is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU Lesser Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ * 
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU Lesser Public License for more details.
+ * 
+ * You should have received a copy of the GNU Lesser Public License
+ * along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#ifndef _VDT_EXP_
+#define _VDT_EXP_
+
+#include "vdtcore_common.h"
+#include <limits>
+
+namespace vdt{
+
+namespace details{
+  
+  const double EXP_LIMIT = 708;
+
+  const double PX1exp = 1.26177193074810590878E-4;
+  const double PX2exp = 3.02994407707441961300E-2;
+  const double PX3exp = 9.99999999999999999910E-1;
+  const double QX1exp = 3.00198505138664455042E-6;
+  const double QX2exp = 2.52448340349684104192E-3;
+  const double QX3exp = 2.27265548208155028766E-1;
+  const double QX4exp = 2.00000000000000000009E0;
+
+  const double LOG2E = 1.4426950408889634073599; // 1/log(2)
+
+  const float MAXLOGF = 88.72283905206835f;
+  const float MINLOGF = -88.f;
+
+  const float C1F =   0.693359375f;
+  const float C2F =  -2.12194440e-4f;
+
+  const float PX1expf = 1.9875691500E-4f;
+  const float PX2expf =1.3981999507E-3f;
+  const float PX3expf =8.3334519073E-3f;
+  const float PX4expf =4.1665795894E-2f;
+  const float PX5expf =1.6666665459E-1f;
+  const float PX6expf =5.0000001201E-1f;
+
+  const float LOG2EF = 1.44269504088896341f;
+
+}
+
+// Exp double precision --------------------------------------------------------
+
+
+/// Exponential Function double precision
+inline double fast_exp(double initial_x){
+
+    double x = initial_x;
+    double px=details::fpfloor(details::LOG2E * x +0.5);
+ 
+    const int32_t n = int32_t(px);
+
+    x -= px * 6.93145751953125E-1;
+    x -= px * 1.42860682030941723212E-6;
+
+    const double xx = x * x;
+
+    // px = x * P(x**2).
+    px = details::PX1exp;
+    px *= xx;
+    px += details::PX2exp;
+    px *= xx;
+    px += details::PX3exp;
+    px *= x;
+
+    // Evaluate Q(x**2).
+    double qx = details::QX1exp;
+    qx *= xx;
+    qx += details::QX2exp;
+    qx *= xx;
+    qx += details::QX3exp;
+    qx *= xx;
+    qx += details::QX4exp;
+
+    // e**x = 1 + 2x P(x**2)/( Q(x**2) - P(x**2) )
+    x = px / (qx - px);
+    x = 1.0 + 2.0 * x;
+
+    // Build 2^n in double.
+    x *= details::uint642dp(( ((uint64_t)n) +1023)<<52);
+
+    if (initial_x > details::EXP_LIMIT)
+            x = std::numeric_limits<double>::infinity();
+    if (initial_x < -details::EXP_LIMIT)
+            x = 0.;
+
+    return x;
+    
+}
+
+// Exp single precision --------------------------------------------------------
+
+/// Exponential Function single precision
+inline float fast_expf(float initial_x) {
+	
+    float x = initial_x;
+
+    float z = details::fpfloor( details::LOG2EF * x +0.5f ); /* floor() truncates toward -infinity. */
+
+    x -= z * details::C1F;
+    x -= z * details::C2F;
+    const int32_t n = int32_t ( z );
+
+    const float x2 = x * x;
+
+    z = x*details::PX1expf;
+    z += details::PX2expf;
+    z *= x;
+    z += details::PX3expf;
+    z *= x;
+    z += details::PX4expf;
+    z *= x;
+    z += details::PX5expf;
+    z *= x;
+    z += details::PX6expf;
+    z *= x2;
+    z += x + 1.0f;
+
+    /* multiply by power of 2 */
+    z *=  details::uint322sp((n+0x7f)<<23);
+
+    if (initial_x > details::MAXLOGF) z=std::numeric_limits<float>::infinity();
+    if (initial_x < details::MINLOGF) z=0.f;
+
+    return z;
+
+  }
+
+//------------------------------------------------------------------------------
+
+} // end namespace vdt
+
+#endif
Index: /branches/2915-AbsoluteSymbol/HeuristicLab.ExtLibs/HeuristicLab.NativeInterpreter/0.1/NativeInterpreter-0.1/lib/vdt/inv.h
===================================================================
--- /branches/2915-AbsoluteSymbol/HeuristicLab.ExtLibs/HeuristicLab.NativeInterpreter/0.1/NativeInterpreter-0.1/lib/vdt/inv.h	(revision 16332)
+++ /branches/2915-AbsoluteSymbol/HeuristicLab.ExtLibs/HeuristicLab.NativeInterpreter/0.1/NativeInterpreter-0.1/lib/vdt/inv.h	(revision 16332)
@@ -0,0 +1,92 @@
+/*
+ * inv.h
+ * An experiment: implement division with the square fo the approximate 
+ * inverse square root.
+ * In other words one transforms a shift, multiplications and sums into a 
+ * sqrt.
+ * 
+ *  Created on: Jun 24, 2012
+ *      Author: Danilo Piparo, Thomas Hauth, Vincenzo Innocente
+ * 
+ * VDT is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU Lesser Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ * 
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU Lesser Public License for more details.
+ * 
+ * You should have received a copy of the GNU Lesser Public License
+ * along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#ifndef INV_H_
+#define INV_H_
+
+#include "vdtcore_common.h"
+#include "sqrt.h"
+#include <cmath>
+#include <limits>
+
+namespace vdt{
+
+//------------------------------------------------------------------------------
+
+/// General implementation of the inversion
+inline double fast_inv_general(double x, const uint32_t isqrt_iterations) {  
+  const uint64_t sign_mask = details::getSignMask(x);
+  const double sqrt_one_over_x = fast_isqrt_general(std::fabs(x),
+                                                   isqrt_iterations);
+  return sqrt_one_over_x*(details::dpORuint64(sqrt_one_over_x , sign_mask ));
+}
+
+//------------------------------------------------------------------------------
+
+/// Four iterations inversion
+inline double fast_inv(double x) {return fast_inv_general(x,4);}
+
+//------------------------------------------------------------------------------
+
+/// Three iterations
+inline double fast_approx_inv(double x) {return fast_inv_general(x,3);}
+
+//------------------------------------------------------------------------------
+
+/// For comparisons
+inline double inv (double x) {return 1./x;}
+
+//------------------------------------------------------------------------------
+// Single precision          
+
+
+
+/// General implementation of the inversion
+inline float fast_invf_general(float x, const uint32_t isqrt_iterations) { 
+  const uint32_t sign_mask = details::getSignMask(x);
+  const float sqrt_one_over_x = fast_isqrtf_general(std::fabs(x),
+                                                   isqrt_iterations);
+  return sqrt_one_over_x*(details::spORuint32(sqrt_one_over_x , sign_mask ));
+}
+
+//------------------------------------------------------------------------------
+
+/// Two iterations
+inline float fast_invf(float x) {return fast_invf_general(x,2);}
+
+//------------------------------------------------------------------------------
+
+/// One iterations
+inline float fast_approx_invf(float x) {return fast_invf_general(x,1);}
+
+//------------------------------------------------------------------------------
+
+/// For comparisons
+inline float invf (float x) {return 1.f/x;}
+
+//------------------------------------------------------------------------------
+
+} // end namespace vdt
+
+#endif /* INV_H_ */
Index: /branches/2915-AbsoluteSymbol/HeuristicLab.ExtLibs/HeuristicLab.NativeInterpreter/0.1/NativeInterpreter-0.1/lib/vdt/log.h
===================================================================
--- /branches/2915-AbsoluteSymbol/HeuristicLab.ExtLibs/HeuristicLab.NativeInterpreter/0.1/NativeInterpreter-0.1/lib/vdt/log.h	(revision 16332)
+++ /branches/2915-AbsoluteSymbol/HeuristicLab.ExtLibs/HeuristicLab.NativeInterpreter/0.1/NativeInterpreter-0.1/lib/vdt/log.h	(revision 16332)
@@ -0,0 +1,207 @@
+/*
+ * log.h
+ * The basic idea is to exploit Pade polynomials.
+ * A lot of ideas were inspired by the cephes math library (by Stephen L. Moshier
+ * moshier@na-net.ornl.gov) as well as actual code. 
+ * The Cephes library can be found here:  http://www.netlib.org/cephes/
+ * 
+ *  Created on: Jun 23, 2012
+ *      Author: Danilo Piparo, Thomas Hauth, Vincenzo Innocente
+ */
+
+/* 
+ * VDT is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU Lesser Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ * 
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU Lesser Public License for more details.
+ * 
+ * You should have received a copy of the GNU Lesser Public License
+ * along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#ifndef LOG_H_
+#define LOG_H_
+
+#include "vdtcore_common.h"
+#include <limits>
+
+namespace vdt{
+
+// local namespace for the constants/functions which are necessary only here
+namespace details{
+
+const double LOG_UPPER_LIMIT = 1e307;
+const double LOG_LOWER_LIMIT = 0;
+
+const double SQRTH = 0.70710678118654752440;
+
+inline double get_log_px(const double x){
+	const double PX1log = 1.01875663804580931796E-4;
+	const double PX2log = 4.97494994976747001425E-1;
+	const double PX3log = 4.70579119878881725854E0;
+	const double PX4log = 1.44989225341610930846E1;
+	const double PX5log = 1.79368678507819816313E1;
+	const double PX6log = 7.70838733755885391666E0;
+
+	double px = PX1log;
+	px *= x;
+	px += PX2log;
+	px *= x;
+	px += PX3log;
+	px *= x;
+	px += PX4log;
+	px *= x;
+	px += PX5log;
+	px *= x;
+	px += PX6log;
+	return px;
+
+}
+
+inline double get_log_qx(const double x){
+	const double QX1log = 1.12873587189167450590E1;
+	const double QX2log = 4.52279145837532221105E1;
+	const double QX3log = 8.29875266912776603211E1;
+	const double QX4log = 7.11544750618563894466E1;
+	const double QX5log = 2.31251620126765340583E1;
+
+	double qx = x;
+	qx += QX1log;
+	qx *=x;
+	qx += QX2log;
+	qx *=x;
+	qx += QX3log;
+	qx *=x;
+	qx += QX4log;
+	qx *=x;
+	qx += QX5log;
+	return qx;
+}
+
+}
+
+// Log double precision --------------------------------------------------------
+inline double fast_log(double x){
+
+	const double original_x = x;
+
+	/* separate mantissa from exponent */
+	double fe;
+	x = details::getMantExponent(x,fe);
+
+	// blending
+	x > details::SQRTH? fe+=1. : x+=x ;
+	x -= 1.0;
+
+	/* rational form */
+	double px =  details::get_log_px(x);
+
+	//for the final formula
+	const double x2 = x*x;
+	px *= x;
+	px *= x2;
+
+	const double qx = details::get_log_qx(x);
+
+	double res = px / qx ;
+
+	res -= fe * 2.121944400546905827679e-4;
+	res -= 0.5 * x2  ;
+
+	res = x + res;
+	res += fe * 0.693359375;
+
+	if (original_x > details::LOG_UPPER_LIMIT)
+		res = std::numeric_limits<double>::infinity();
+	if (original_x < details::LOG_LOWER_LIMIT) // THIS IS NAN!
+		res =  - std::numeric_limits<double>::quiet_NaN();
+
+	return res;
+
+}
+
+// Log single precision --------------------------------------------------------
+
+
+
+namespace details{
+
+const float LOGF_UPPER_LIMIT = MAXNUMF;
+const float LOGF_LOWER_LIMIT = 0;
+
+const float PX1logf = 7.0376836292E-2f;
+const float PX2logf	= -1.1514610310E-1f;
+const float PX3logf	= 1.1676998740E-1f;
+const float PX4logf	= -1.2420140846E-1f;
+const float PX5logf	= 1.4249322787E-1f;
+const float PX6logf	= -1.6668057665E-1f;
+const float PX7logf	= 2.0000714765E-1f;
+const float PX8logf	= -2.4999993993E-1f;
+const float PX9logf	= 3.3333331174E-1f;
+
+inline float get_log_poly(const float x){
+	float y = x*PX1logf;
+	y += PX2logf;
+	y *= x;
+	y += PX3logf;
+	y *= x;
+	y += PX4logf;
+	y *= x;
+	y += PX5logf;
+	y *= x;
+	y += PX6logf;
+	y *= x;
+	y += PX7logf;
+	y *= x;
+	y += PX8logf;
+	y *= x;
+	y += PX9logf;
+	return y;
+}
+
+const float SQRTHF = 0.707106781186547524f;
+
+}
+
+// Log single precision --------------------------------------------------------
+inline float fast_logf( float x ) {
+
+	const float original_x = x;
+
+	float fe;
+	x = details::getMantExponentf( x, fe);
+
+	x > details::SQRTHF? fe+=1.f : x+=x ;
+	x -= 1.0f;
+
+	const float x2 = x*x;
+
+	float res = details::get_log_poly(x);
+	res *= x2*x;
+
+	res += -2.12194440e-4f * fe;
+	res +=  -0.5f * x2;
+
+	res= x + res;
+
+	res += 0.693359375f * fe;
+
+	if (original_x > details::LOGF_UPPER_LIMIT)
+		res = std::numeric_limits<float>::infinity();
+	if (original_x < details::LOGF_LOWER_LIMIT)
+		res = -std::numeric_limits<float>::quiet_NaN();
+
+	return res;
+}
+
+
+//------------------------------------------------------------------------------
+
+} //vdt namespace
+
+#endif /* LOG_H_ */
